<?

define('MSG_PVT',0x00000001);
define('MSG_CRA',0x00000002);
define('MSG_RCV',0x00000004);
define('MSG_SNT',0x00000008);
define('MSG_ATT',0x00000010);
define('MSG_TRS',0x00000020);
define('MSG_ORP',0x00000040);
define('MSG_KFS',0x00000080);
define('MSG_LOC',0x00000100);
define('MSG_HLD',0x00000200);
define('MSG_FRQ',0x00000400);
define('MSG_RRQ',0x00000800);
define('MSG_RRC',0x00001000);
define('MSG_ARQ',0x00002000);
define('MSG_URQ',0x00004000);
define('MSG_ARS',0x00008000);
define('MSG_DIR',0x00010000);
define('MSG_ZON',0x00020000);
define('MSG_HUB',0x00040000);
define('MSG_IMM',0x00080000);
define('MSG_XMA',0x00100000);
define('MSG_LOK',0x00200000);
define('MSG_CFM',0x00400000);
define('MSG_SCN',0x00800000);
define('MSG_DEL',0x01000000);
define('MSG_TFS',0x02000000);
define('MSG_DFS',0x04000000);
define('MSG_CRY',0x08000000);

class C_htmlreader
{
	var $Base;
	
	function Open($area)
	{
		$this->Base = new C_msgbase;
		return $this->Base->Open($area);
	}

	function Close()
	{
		$this->Base->Close();
		unset($this->Base);
	}

	function ReadMsgHeader($num)
	{
		$result = $this->Base->ReadMsgHeader($num);
		$result->From = htmlspecialchars(convert_cyr_string($result->From,'d','k'));	
		$result->To = htmlspecialchars(convert_cyr_string($result->To,'d','k'));
		$result->Subj = htmlspecialchars(convert_cyr_string($result->Subj,'d','k'));
		return $result;
	}

	function ReadMsgBody($num)
	{
		return htmlspecialchars(convert_cyr_string($this->Base->ReadMsgBody($num),'d','k'));
	}
	
	function GetNumMsgs()
	{
		return $this->Base->GetNumMsgs();
	}
}

class C_msgbase
{
	var $Areatag;
	var $Descr;
	var $Base;
	var $Type;
	
	function Open($areaname, $create_if_not_exists = 0)
	{
		GLOBAL $CONFIG;
		if (($num = $CONFIG->Areas->FindAreaNum($areaname))==-1)
		{
			tolog('Q',"Area $areaname not found");
			return 0;
		}
		$this->Areatag = $CONFIG->Areas->Vals[$num]->EchoTag;
		$this->Descr = (isset($CONFIG->Areas->Vals[$num]->Options['-d'])?($CONFIG->Areas->Vals[$num]->Options['-d']):($CONFIG->Areas->Vals[$num]->EchoTag));
		$this->Type = ((@$CONFIG->Areas->Vals[$num]->Options['-b'])?(strtolower($CONFIG->Areas->Vals[$num]->Options['-b'])):'opus');
		$Path = $CONFIG->Areas->Vals[$num]->Path;
		switch ($this->Type):
			case('opus'):
				include_once "C_opus.php";
				$this->Base = new C_opusbase;
				break;
			case('squish'):
				include_once "C_squish.php";
				$this->Base = new C_squishbase;
				break;
			case('jam'):
				include_once "C_jam.php";
				$this->Base = new C_jambase;
				break;
			case('fips'):
				include_once "C_fips.php";
				$this->Base = new C_fipsbase;
				break;
			case('phpbb'):
				include_once "C_phpbb.php";
				$this->Base = new C_phpbbbase;
				break;
			case('ipb'):
				include_once "C_ipb.php";
				$this->Base = new C_ipbbase;
				break;
			case('mysql'):
				include_once "C_mysql.php";
				$this->Base = new C_mysqlbase;
				break;
			default:
				return 0;
		endswitch;
	
		$res = $this->Base->OpenBase($Path);
		if (!$res && $create_if_not_exists):
			if ($this->Base->CreateBase($Path)):
				$res = $this->Base->OpenBase($Path);
			else:
				$res = 0;
			endif;
		endif;
		if ($res):
			return 1;
		else:
			unset($this->Base);
			return 0;
		endif;
	}
	
	function WriteMessage($hdr,$msg)
	{
		return $this->Base->WriteMessage($hdr,$msg);
	}

	function SetAttr($msg,$attr)
	{
		return $this->Base->SetAttr($msg,$attr);
	}

	function ReadMsgHeader($num)
	{
		return $this->Base->ReadMsgHeader($num);
	}

	function ReadMsgBody($num)
	{
		return $this->Base->ReadMsgBody($num);
	}

	function Close()
	{
		$this->Base->CloseBase();
		unset($this->Base);
	}
		
	function GetNumMsgs()
	{
		return $this->Base->GetNumMsgs();
	}
}

class C_msgheader
{
	var $From;
	var $FromAddr;
	var $To;
	var $ToAddr;
	var $Subj;
	var $WDate;
	var $ADate;
	var $Attrs;
}

?>
